#define CATCH_CONFIG_MAIN
#define CATCH_CONFIG_ENABLE_BENCHMARKING

#include <catch2/catch_test_macros.hpp>
#include <catch2/benchmark/catch_benchmark.hpp>
#include <iostream>

#include "MapData.h"

struct TestSample {
    short X, Y, Z, expected;
};

TEST_CASE("LineTracing") {
    MapData map;
    map.import_obj("../../tests/example_maps/7d24.blv.obj");
    auto& facets = map.facets;

    std::vector<Vertex> way = {{-4124,-3570,-63},{-4058,-3570,-64},{-3992,-3636,-64},{-3926,-3702,-64},{-3860,-3702,-64},{-3794,-3702,-64},{-3728,-3702,-64},{-3662,-3702,-64},{-3596,-3702,-64},{-3530,-3702,-64},{-3464,-3702,-64},{-3398,-3702,-64},{-3332,-3702,-64},{-3266,-3636,-64},{-3200,-3570,-64},{-3134,-3504,-64},{-3068,-3438,-64},{-3002,-3372,-64},{-2936,-3306,-64},{-2936,-3240,-64},{-2936,-3174,-64},{-2936,-3108,-64},{-2936,-3042,-64},{-2936,-2976,-64},{-2936,-2910,-64},{-2936,-2844,-64},{-2936,-2778,-64},{-2936,-2712,-64},{-2870,-2646,-64},{-2804,-2580,-64},{-2738,-2514,-64},{-2672,-2448,-64},{-2606,-2382,-64},{-2606,-2316,-60},{-2606,-2250,-54},{-2606,-2184,-49},{-2606,-2118,-43},{-2606,-2052,-38},{-2606,-1986,-32},{-2606,-1920,-27},{-2606,-1854,-21},{-2606,-1788,-16},{-2606,-1722,-10},{-2606,-1656,-5},{-2606,-1590,0},{-2606,-1524,0},{-2606,-1458,0},{-2606,-1392,0},{-2606,-1326,0},{-2606,-1260,0},{-2540,-1194,0},{-2474,-1194,0},{-2408,-1194,0},{-2342,-1194,0},{-2276,-1194,0},{-2210,-1194,0},{-2144,-1194,0},{-2078,-1194,0},{-2012,-1194,0},{-1946,-1194,0},{-1880,-1194,0},{-1814,-1194,0},{-1748,-1194,0},{-1682,-1194,0},{-1616,-1194,0},{-1550,-1194,0},{-1484,-1194,0},{-1418,-1194,0},{-1352,-1194,0},{-1286,-1194,0},{-1220,-1194,0},{-1154,-1194,0},{-1088,-1194,0},{-1022,-1194,0},{-956,-1194,0},{-890,-1194,0},{-824,-1194,0},{-758,-1128,0},{-692,-1128,0},{-626,-1128,0}};

    for (auto& v : way) v.z += 35;

    REQUIRE(traceLine(facets, way[12], way[13]));
    REQUIRE(!traceLine(facets, way.front(), way.back()));

    auto groups = map.facet_groups_on_line(way.front(), way.back());
    std::cout << "Groups in target area: " << groups.size() << std ::endl;
    REQUIRE(!traceLine(groups, way.front(), way.back()));

    auto point_repr = [](const Vertex& v){
        return std::to_string(v.x) + "," + std::to_string(v.y) + "," + std::to_string(v.z);
    };

    unsigned int success_count = 0;
    for (int i = 0; i < way.size() - 1; ++i) {
        auto& p1 = way[i];
        auto& p2 = way[i+1];

        bool success = traceLine(facets, p1, p2);
        if (success) {
            ++success_count;
        } else {
            std::cout << "Fail while tracing line between points " << i << " and " << (i + 1) << ":";
            std::cout << point_repr(p1) << " - " << point_repr(p2) << std::endl;
        }

        auto groups = map.facet_groups_on_line(p1, p2);
        bool area_success = traceLine(groups, p1, p2);
        REQUIRE(area_success == success);

        bool way_success = map.traceWay(p1, p2, {false, 0, 35, 40});
        if (!way_success) {
            --success_count;
            std::cout << "Fail while tracing way between points " << i << " and " << (i + 1) << ":";
            std::cout << point_repr(p1) << " - " << point_repr(p2) << std::endl;
        }
    }
    REQUIRE(success_count == way.size() - 1);
}

TEST_CASE("FloorLevel") {
    MapData map;
    map.import_obj("../../tests/example_maps/7d24.blv.obj");

    std::cout << "Facets loaded: " << map.facets.size() << std::endl;
    std::vector<TestSample> test_data = {{-2388,4377,181,174},{-5269,-2362,-63,-64},{-5155,-2989,193,192},{-4984,-2818,1,0},{-4927,-2818,-15,-16},{-4699,-2761,49,48},{-4699,-1678,15,14},{-3958,-2419,-47,-48},{-3901,-2362,-31,-32},{-3502,1685,-831,-832},{-2875,-2305,-59,-60},{-2875,-2248,-54,-55},{-2875,-2191,-49,-50},{-2875,-2134,-44,-45},{-2875,-2077,-40,-41},{-2875,-2020,-35,-36},{-2875,-1963,-30,-31},{-2875,-1906,-25,-26},{-2875,-1849,-21,-22},{-2875,-1792,-16,-17},{-2875,-1735,-11,-12},{-2875,-1678,-6,-7},{-2875,-1621,-2,-3},{-2875,2654,-52,-53},{-2875,2711,-46,-47},{-2875,4136,257,256},{-2818,-3616,5,4},{-2818,-3559,-1,-2},{-2818,2597,-36,-37},{-2590,3452,-14,-15},{-2590,3851,-23,-24},{-2590,4250,241,240},{-2533,3338,-19,-20},{-2533,4250,233,232},{-2533,4307,210,209},{-2476,2882,-26,-27},{-2476,2996,-17,-18},{-2476,4193,248,247},{-2476,4250,225,224},{-2419,-3103,4,3},{-2419,2768,-9,-10},{-2419,3281,-18,-19},{-2419,4193,232,231},{-2419,4250,200,199},{-2419,4421,191,190},{-2362,3281,-22,-23},{-2362,4022,-20,-21},{-2362,4250,184,183},{-2362,4307,173,172},{-2362,4364,165,164},{-2362,4421,182,181},{-2305,4307,142,141},{-2305,4364,157,156},{-2305,4421,174,173},{-2305,4478,192,191},{-2248,4307,129,128},{-2248,4364,141,140},{-2191,4421,138,137},{-2191,4478,154,153},{-2134,3509,-4,-5},{-2134,3566,-27,-28},{-2134,4478,135,134},{-2077,4250,86,85},{-2077,4307,112,111},{-2020,3680,-3,-4},{-2020,4193,52,51},{-2020,4250,79,78},{-2020,4307,91,90},{-2020,4364,117,116},{-1963,1571,145,144},{-1963,2426,17,16},{-1963,4136,32,31},{-1963,4193,72,71},{-1963,4250,96,95},{-1963,4364,124,123},{-1906,2027,121,120},{-1906,3908,-32,-33},{-1906,4022,-5,-6},{-1906,4136,61,60},{-1906,4193,87,86},{-1906,4250,111,110},{-1849,2084,97,96},{-1849,3965,-8,-9},{-1792,-3274,3,2},{-1792,-3217,0,-1},{-1792,2141,73,72},{-1792,2255,25,24},{-1051,-1393,358,357},{-1051,-652,359,358},{-994,-1393,330,329},{-994,-1336,302,301},{-994,-652,331,330},{-937,-1393,301,300},{-937,-1336,273,272},{-880,-652,274,273},{-709,-481,287,286},{-709,-424,312,311},{-709,-367,336,335},{-652,-1735,333,332},{-652,-1678,346,345},{-652,-1621,321,320},{-652,-367,343,342},{-595,-1735,308,307},{-595,-1678,332,331},{-595,-367,318,317},{-538,-1735,284,283},{-82,-1051,33,32},{32,-4528,6,5},{89,-4813,20,19},{89,-4699,14,13},{89,-4642,12,11},{89,-4585,9,8},{89,-4414,2,1},{146,-4984,29,28},{146,-4927,26,25},{146,-4870,23,22},{146,-4642,11,10},{146,-4528,7,6},{203,-4756,16,15},{203,-4585,10,9},{203,-4528,8,7},{203,-2932,259,258},{260,-4756,18,17},{260,-4129,261,260},{260,-4072,272,271},{260,-4015,281,280},{260,-3274,276,275},{260,-3217,278,277},{260,-3160,280,279},{260,-3103,282,281},{260,-2989,286,285},{317,-4813,21,20},{317,-4756,19,18},{317,-4585,13,12},{317,-4186,277,276},{317,-4129,288,287},{317,-4072,299,298},{317,-3274,304,303},{317,-3217,306,305},{317,-3103,310,309},{317,-2020,305,304},{374,-5041,30,29},{374,-4984,28,27},{374,-4129,314,313},{374,-4072,325,324},{374,-4015,334,333},{374,-3217,335,334},{374,-2077,362,361},{374,32,363,362},{431,-4072,352,351},{431,-4015,361,360},{545,-310,285,284},{602,-1678,322,321},{602,-310,309,308},{659,-1678,347,346},{659,-424,320,319},{659,-367,344,343},{716,-1621,307,306},{716,-1564,283,282},{3395,203,36,35},{3452,203,42,41},{3509,203,48,47},{3566,203,55,54},{3680,-196,65,64},{3908,-1051,-12,-13},{3908,260,81,80},{3908,374,113,112},{4022,-1279,-33,-34},{4022,-1165,-28,-29},{4079,-1336,-41,-42},{4079,-1279,-38,-39},{4136,-1279,-43,-44},{4193,-1051,-39,-40},{4250,-1393,-60,-61},{4250,-1336,-57,-58},{4307,-1393,-66,-67},{4307,-1222,-58,-59},{4307,-1165,-55,-56},{4307,-1051,-50,-51},{4364,-1450,-75,-76},{4364,-1393,-72,-73},{4364,-1336,-69,-70},{4421,-2419,-159,-160},{4421,-1507,-85,-86},{4421,-1450,-82,-83},{4421,-1393,-79,-80},{4421,-1336,-76,-77},{4421,-1279,-73,-74},{4421,-1051,-61,-62},{4478,-1564,-94,-95},{4478,-1507,-91,-92},{4478,-1450,-88,-89},{4535,-1678,-111,-112},{4535,-1621,-104,-105},{4535,-1564,-95,-96},{4535,-1507,-92,-93},{4535,-1450,-89,-90},{4535,-1393,-86,-87},{4535,-1336,-83,-84},{4535,-1279,-80,-81},{4535,-1108,-70,-71},{4592,-1792,-130,-131}};

    int succeed = 0;
    int expected = static_cast<int>(test_data.size());

    for (auto& sample : test_data) {
        point3d<short> position {sample.X, sample.Y, sample.Z};
        FloorInfo floor_info {};
        getFloorLevel(map.facets, position, floor_info);
        if (floor_info.floor && abs(floor_info.level - sample.expected) <= 8) {
            ++succeed;
        } else {
            std::cout << sample.X << "," << sample.Y << "," << sample.Z << ": expected " << sample.expected << ", got " << floor_info.level << std::endl;
        }
    }

    REQUIRE(abs(succeed - expected) < test_data.size() / 20);
}

#define AREA_SIZE_BENCHMARK(PRECISION) \
map.cube_area_side = PRECISION;\
map.make_facet_groups();               \
std::cout << "Facets in benchmark area of size " << #PRECISION << ": " << map.facet_group_from_point(position.x, position.y, position.z)->size() << std::endl;\
{                                       \
auto facets = map.facet_group_from_point(position.x, position.y, position.z);                                       \
BENCHMARK("area facets, cell side: " #PRECISION) {                                                                                                            \
    FloorInfo floor_info;                                   \
    getFloorLevel(*facets, position, floor_info);\
};};

TEST_CASE("FloorLevel_performance_areas_precision") {
    MapData map;
    map.import_obj("../../tests/example_maps/7d24.blv.obj");

    Vertex position {-2388,4377,181};

    AREA_SIZE_BENCHMARK(256);
    AREA_SIZE_BENCHMARK(400);
    AREA_SIZE_BENCHMARK(512);
}

TEST_CASE("FloorLevel_performance_areas") {
    MapData map;
    map.import_obj("../../tests/example_maps/7d24.blv.obj");

    std::vector<TestSample> test_data = {{-2388,4377,181,174},{-5269,-2362,-63,-64},{-5155,-2989,193,192},{-4984,-2818,1,0},{-4927,-2818,-15,-16},{-4699,-2761,49,48},{-4699,-1678,15,14},{-3958,-2419,-47,-48},{-3901,-2362,-31,-32},{-3502,1685,-831,-832},{-2875,-2305,-59,-60},{-2875,-2248,-54,-55},{-2875,-2191,-49,-50},{-2875,-2134,-44,-45},{-2875,-2077,-40,-41},{-2875,-2020,-35,-36},{-2875,-1963,-30,-31},{-2875,-1906,-25,-26},{-2875,-1849,-21,-22},{-2875,-1792,-16,-17},{-2875,-1735,-11,-12},{-2875,-1678,-6,-7},{-2875,-1621,-2,-3},{-2875,2654,-52,-53},{-2875,2711,-46,-47},{-2875,4136,257,256},{-2818,-3616,5,4},{-2818,-3559,-1,-2},{-2818,2597,-36,-37},{-2590,3452,-14,-15},{-2590,3851,-23,-24},{-2590,4250,241,240},{-2533,3338,-19,-20},{-2533,4250,233,232},{-2533,4307,210,209},{-2476,2882,-26,-27},{-2476,2996,-17,-18},{-2476,4193,248,247},{-2476,4250,225,224},{-2419,-3103,4,3},{-2419,2768,-9,-10},{-2419,3281,-18,-19},{-2419,4193,232,231},{-2419,4250,200,199},{-2419,4421,191,190},{-2362,3281,-22,-23},{-2362,4022,-20,-21},{-2362,4250,184,183},{-2362,4307,173,172},{-2362,4364,165,164},{-2362,4421,182,181},{-2305,4307,142,141},{-2305,4364,157,156},{-2305,4421,174,173},{-2305,4478,192,191},{-2248,4307,129,128},{-2248,4364,141,140},{-2191,4421,138,137},{-2191,4478,154,153},{-2134,3509,-4,-5},{-2134,3566,-27,-28},{-2134,4478,135,134},{-2077,4250,86,85},{-2077,4307,112,111},{-2020,3680,-3,-4},{-2020,4193,52,51},{-2020,4250,79,78},{-2020,4307,91,90},{-2020,4364,117,116},{-1963,1571,145,144},{-1963,2426,17,16},{-1963,4136,32,31},{-1963,4193,72,71},{-1963,4250,96,95},{-1963,4364,124,123},{-1906,2027,121,120},{-1906,3908,-32,-33},{-1906,4022,-5,-6},{-1906,4136,61,60},{-1906,4193,87,86},{-1906,4250,111,110},{-1849,2084,97,96},{-1849,3965,-8,-9},{-1792,-3274,3,2},{-1792,-3217,0,-1},{-1792,2141,73,72},{-1792,2255,25,24},{-1051,-1393,358,357},{-1051,-652,359,358},{-994,-1393,330,329},{-994,-1336,302,301},{-994,-652,331,330},{-937,-1393,301,300},{-937,-1336,273,272},{-880,-652,274,273},{-709,-481,287,286},{-709,-424,312,311},{-709,-367,336,335},{-652,-1735,333,332},{-652,-1678,346,345},{-652,-1621,321,320},{-652,-367,343,342},{-595,-1735,308,307},{-595,-1678,332,331},{-595,-367,318,317},{-538,-1735,284,283},{-82,-1051,33,32},{32,-4528,6,5},{89,-4813,20,19},{89,-4699,14,13},{89,-4642,12,11},{89,-4585,9,8},{89,-4414,2,1},{146,-4984,29,28},{146,-4927,26,25},{146,-4870,23,22},{146,-4642,11,10},{146,-4528,7,6},{203,-4756,16,15},{203,-4585,10,9},{203,-4528,8,7},{203,-2932,259,258},{260,-4756,18,17},{260,-4129,261,260},{260,-4072,272,271},{260,-4015,281,280},{260,-3274,276,275},{260,-3217,278,277},{260,-3160,280,279},{260,-3103,282,281},{260,-2989,286,285},{317,-4813,21,20},{317,-4756,19,18},{317,-4585,13,12},{317,-4186,277,276},{317,-4129,288,287},{317,-4072,299,298},{317,-3274,304,303},{317,-3217,306,305},{317,-3103,310,309},{317,-2020,305,304},{374,-5041,30,29},{374,-4984,28,27},{374,-4129,314,313},{374,-4072,325,324},{374,-4015,334,333},{374,-3217,335,334},{374,-2077,362,361},{374,32,363,362},{431,-4072,352,351},{431,-4015,361,360},{545,-310,285,284},{602,-1678,322,321},{602,-310,309,308},{659,-1678,347,346},{659,-424,320,319},{659,-367,344,343},{716,-1621,307,306},{716,-1564,283,282},{3395,203,36,35},{3452,203,42,41},{3509,203,48,47},{3566,203,55,54},{3680,-196,65,64},{3908,-1051,-12,-13},{3908,260,81,80},{3908,374,113,112},{4022,-1279,-33,-34},{4022,-1165,-28,-29},{4079,-1336,-41,-42},{4079,-1279,-38,-39},{4136,-1279,-43,-44},{4193,-1051,-39,-40},{4250,-1393,-60,-61},{4250,-1336,-57,-58},{4307,-1393,-66,-67},{4307,-1222,-58,-59},{4307,-1165,-55,-56},{4307,-1051,-50,-51},{4364,-1450,-75,-76},{4364,-1393,-72,-73},{4364,-1336,-69,-70},{4421,-2419,-159,-160},{4421,-1507,-85,-86},{4421,-1450,-82,-83},{4421,-1393,-79,-80},{4421,-1336,-76,-77},{4421,-1279,-73,-74},{4421,-1051,-61,-62},{4478,-1564,-94,-95},{4478,-1507,-91,-92},{4478,-1450,-88,-89},{4535,-1678,-111,-112},{4535,-1621,-104,-105},{4535,-1564,-95,-96},{4535,-1507,-92,-93},{4535,-1450,-89,-90},{4535,-1393,-86,-87},{4535,-1336,-83,-84},{4535,-1279,-80,-81},{4535,-1108,-70,-71},{4592,-1792,-130,-131}};
    int fails_count = 0;
    for (auto& sample : test_data) {
        FloorInfo res1{}, res2{};
        point3d<short> pos {sample.X, sample.Y, sample.Z};

        auto area_facets = map.facet_group_from_point(pos.x, pos.y, pos.z);
        getFloorLevel(map.facets, pos, res1);
        if (area_facets != nullptr) getFloorLevel(*area_facets, pos, res2);

        if (res1.level != res2.level) {
            std::cout << res1.level << " != " << res2.level << std::endl;
        }
    }
    REQUIRE(fails_count <= 2);

    Vertex position {-2388,4377,181};
    FloorInfo floor_info {};

    std::cout << "Total facets: " << map.facets.size() << std::endl;
    BENCHMARK("all facets") {
        auto& facets = map.facets;
        getFloorLevel(facets, position, floor_info);
    };

    std::cout << "Facets in benchmark area: " << map.facet_group_from_point(position.x, position.y, position.z)->size() << std::endl;
    auto facets = map.facet_group_from_point(position.x, position.y, position.z);
    BENCHMARK("area facets") {
        getFloorLevel(*facets, position, floor_info);
    };
}

TEST_CASE("FloorLevel_performance") {
    MapData map;
    map.import_obj("../../tests/example_maps/7d24.blv.obj");

    Vertex position {-2388,4377,181};
    FloorInfo floor_info {};

    std::vector<const std::vector<Facet>*> groups {&map.facets};

    BENCHMARK("std"){getFloorLevel(groups, position, floor_info);};
}

TEST_CASE("TraceLine_performance") {
    MapData map;
    map.import_obj("../../tests/example_maps/7d24.blv.obj");
    auto& facets = map.facets;

    std::vector<Vertex> way = {{-4124,-3570,-63},{-4058,-3570,-64},{-3992,-3636,-64},{-3926,-3702,-64},{-3860,-3702,-64},{-3794,-3702,-64},{-3728,-3702,-64},{-3662,-3702,-64},{-3596,-3702,-64},{-3530,-3702,-64},{-3464,-3702,-64},{-3398,-3702,-64},{-3332,-3702,-64},{-3266,-3636,-64},{-3200,-3570,-64},{-3134,-3504,-64},{-3068,-3438,-64},{-3002,-3372,-64},{-2936,-3306,-64},{-2936,-3240,-64},{-2936,-3174,-64},{-2936,-3108,-64},{-2936,-3042,-64},{-2936,-2976,-64},{-2936,-2910,-64},{-2936,-2844,-64},{-2936,-2778,-64},{-2936,-2712,-64},{-2870,-2646,-64},{-2804,-2580,-64},{-2738,-2514,-64},{-2672,-2448,-64},{-2606,-2382,-64},{-2606,-2316,-60},{-2606,-2250,-54},{-2606,-2184,-49},{-2606,-2118,-43},{-2606,-2052,-38},{-2606,-1986,-32},{-2606,-1920,-27},{-2606,-1854,-21},{-2606,-1788,-16},{-2606,-1722,-10},{-2606,-1656,-5},{-2606,-1590,0},{-2606,-1524,0},{-2606,-1458,0},{-2606,-1392,0},{-2606,-1326,0},{-2606,-1260,0},{-2540,-1194,0},{-2474,-1194,0},{-2408,-1194,0},{-2342,-1194,0},{-2276,-1194,0},{-2210,-1194,0},{-2144,-1194,0},{-2078,-1194,0},{-2012,-1194,0},{-1946,-1194,0},{-1880,-1194,0},{-1814,-1194,0},{-1748,-1194,0},{-1682,-1194,0},{-1616,-1194,0},{-1550,-1194,0},{-1484,-1194,0},{-1418,-1194,0},{-1352,-1194,0},{-1286,-1194,0},{-1220,-1194,0},{-1154,-1194,0},{-1088,-1194,0},{-1022,-1194,0},{-956,-1194,0},{-890,-1194,0},{-824,-1194,0},{-758,-1128,0},{-692,-1128,0},{-626,-1128,0}};

    BENCHMARK("traceLine") {
         traceLine(facets, way.front(), way.back());
         for (int i = 0; i < way.size() - 1; ++i) traceLine(facets, way[i], way[i+1]);
    };

    BENCHMARK("traceLine_areas") {
        traceLine(facets, way.front(), way.back());
        for (int i = 0; i < way.size() - 1; ++i) {
            auto& p1 = way[i];
            auto& p2 = way[i+1];
            auto groups = map.facet_groups_on_line(p1, p2);
            traceLine(groups, p1, p2);
        }
    };
}